program nibbles;
{ Instead of the normal 80x25 text graphics using chr$(219) "", we will be
  using chr$(220)"" and chr$(223) "" and chr$(219) "" to mimic an 80x50
  pixel screen.
- quoted from Micro$oft NIBBLES }
uses
  crt, nibbsnak, nibbluni, nibbserv, nibbtext, nibblevl, nibbRule, nibbMenu;
const
  versionText =' vNibbles ver &1.20b                               Copyright (C) Vlado 1999/2000';
var
  testMode: boolean;

procedure main;
var
  ch: char;
  imSpiel, i, j, jAnzahl: byte;
  leer: string;
  ticks: longint absolute $0000:$046C;
  abfragen, zielTicks: longint;
  mausInSpiel: boolean;
  procedure eingabe(richtung: byte);
  var
    k: byte;
  begin
    if richtung > 0 then
      for k:= 1 to spieler do
        if schlange[k]^.lebt then
          schlange[k]^.getNewDir(richtung);
  end;
begin
  ch:=' ';
  abfragen:= 0;
  mausInSpiel:= FALSE;
  imSpiel:= spieler;
  jAnzahl:= 0;
  for i := 1 to nibbluni.spieler do
  begin
    schlange[i]^.aufstellen;
    schlange[i]^.message('Get ready!');
    if schlange[i]^.links = nibbMaus.mausLinks then mausInSpiel:= true else
      if ((schlange[i]^.links = nibbljoy.j1l) and (jAnzahl = 0)) then
        jAnzahl:= 1 else
          if schlange[i]^.links = nibbljoy.j2l then jAnzahl:= 2;
  end;
  readkey;
  nibbRule.initZiel;
  for i := 1 to nibbluni.spieler do
  begin
    leer:='';
    for j:= 1 to (nameLength - length(schlange[i]^.name)) do leer:= leer + ' ';
    schlange[i]^.message(schlange[i]^.name + ': ' + leer + int2str(schlange[i]^.punkte));
  end;
  zielTicks := ticks + verzoegerung;
  repeat                                 {SpielHauptSchleife}
    nibbljoy.abfragen(jAnzahl);
    eingabe(nibbljoy.richtung(1));
    eingabe(nibbljoy.richtung(2));
    if mausInSpiel then eingabe(nibbMaus.richtung);
    inc(abfragen);
    if keypressed then
    begin
      ch:= readkey;
      if ord(ch) = 0 then ch:= readkey;
      if ch = char(27) then
      begin
        for i:= 1 to nibbluni.spieler do schlange[i]^.lebt:= FALSE;
        imSpiel:= 0;
      end
      else eingabe(ord(ch));
    end;
    if ticks >= zielTicks then
    if imSpiel > 0 then
    begin
      if testMode then
      begin
        gotoxy(47, 25);
        write('Input calls per step: ', abfragen: 10);
      end;
      abfragen:= 0;
      inc( zielTicks, verzoegerung );
      for i:= 1 to spieler do
        if not(schlange[i]^.bewege) then dec(imSpiel);
    end;
  until nibbrule.spielEnde( imSpiel );
  for i:= 1 to nibbluni.spieler do schlange[i]^.ende; { lebt bleibt erhalten }
  if ch <> char(27) then nibbrule.bilanz;
end;

procedure init;
  procedure KonfigurationsdateiLesen;
  var
    zeile: string;
    abschnitt, z: byte;
    datei: text;
  begin
    write('Loading configuration file "', configFile, '"...');
    schlangenDaten:= nil;
    z:= 0;
    abschnitt:= 0;
    assign(datei, configFile);
    {$i-}
    reset(datei);
    {$i+}
    if ioresult = 0 then
    begin
      while not eof(datei) do
      begin
        readln(datei, zeile);
        if ((zeile[1] <> '/') and (zeile <> '')) then
          if zeile[1] = '[' then
          begin
            inc(abschnitt);
            z:= 0;
          end
          else
          begin
            inc(z);
            case abschnitt of
              1: case z of                                          {general}
                   1: nibbluni.verzoegerung:= zeilenEndWert(zeile);
                   2: nibbluni.wFarb:= zeilenEndWert(zeile);
                   3: nibbluni.bFarb:= zeilenEndWert(zeile);
                   4: begin
                        delete(zeile, 1, 9);
                        nibbluni.sprache:= zeile;
                      end;
                   5: testMode:= (zeilenEndWert(zeile) = 1);
                   6: begin
                        delete(zeile, 1, 6);
                        if zeile <> '' then
                          nibblevl.levelName:= nibbserv.nurName(zeile);
                      end;
                   7: nibbluni.maxPunkte := zeilenEndWert( zeile );
                 end;
              2: nibbljoy.init(1, zeile);                            {joy1}
              3: nibbljoy.init(2, zeile);                            {joy2}
              4: neuSchlange(zeile);                                {snakes}
            end;
          end;
      end;
      close(datei);
      erfolgMeldung;
    end
    else fehlerMeldung;
  end;
begin
  clrscr;
  randomize;
  spieler:= 0;
  testMode:= false;
  verzoegerung:= 2;
  nibbluni.wFarb:= 99;
  nibbluni.bFarb:= 99;
  nibblevl.levelName:='level4';
  sprache:= '';
  nibbluni.maxPunkte := 99;
  write('Initialising mouse... ');
  if nibbMaus.init then erfolgMeldung else fehlerMeldung;
  nibbMaus.versteckeCursor;
  KonfigurationsdateiLesen;
  write('Loading language file "' + sprache + '.nlf"... ');
  if nibbtext.texteLesen(sprache) then erfolgMeldung else fehlerMeldung;
  csrOff;
end;

procedure ende;
  procedure KonfigurationsdateiSchreiben;
  var
    datei: text;
    zeile: string;
  begin
    write('Writing configuration file "', configFile, '"...');
    assign(datei, configFile);
    {$i-}
    rewrite(datei);
    {$i+}
    if ioresult = 0 then
    begin
      writeln(datei, '// vNibbles configuration file');
      writeln(datei, '// Do not edit this file unless you know what you are doing.');
      writeln(datei, '');
      writeln(datei, '[general]');
      writeln(datei, 'speed=' + int2str(nibbluni.verzoegerung));
      writeln(datei, 'wall-color=' + int2str(nibbluni.wFarb));
      writeln(datei, 'background-color=' + int2str(nibbluni.bFarb));
      writeln(datei, 'language=' + nibbluni.sprache);
      if testMode then zeile:= 'testMode=1' else zeile:= 'testMode=0';
      writeln(datei, zeile);
      writeln(datei, 'level=' + nibblevl.levelName);
      writeln( datei, 'maxPoints=' + int2str( nibbluni.maxPunkte ) );
      writeln(datei, '');
      writeln(datei, '[joy1]');
      writeln(datei, '// minX midX maxX minY midY maxY xTolerance yTolerance');
      writeln(datei, nibbljoy.infoZeile(1));
      writeln(datei, '[joy2]');
      writeln(datei, nibbljoy.infoZeile(2));
      writeln(datei, '');
      writeln(datei, '[snakes]');
      zeile:= '// name left right up down color';
      repeat
        writeln(datei, zeile);
      until not loescheSchlange(zeile); {disposes Schlangen, gibt Info}
      close(datei);
      erfolgMeldung;
    end
    else fehlerMeldung;
  end;
begin
  textbackground(0);
  textcolor(7);
  clrscr;
  KonfigurationsdateiSchreiben; {schlangen werden disposed}
  writeln;
  write('Visit the vNIBBLES-homepage: ');
  textcolor(red);
  writeln('http://host4u.upws.net/personal/vlado');
  textcolor(7);
  csrOn;
end;

procedure auswahl;
var
  wahl, i: byte;
  menutext: string[82];
  sFarben: nibbLevl.spielerFarbTyp; { Farbe der Schlangen }
begin
  wahl:= 2;
  menuText:= VersionText;
  nibbmenu.initMenu(4, spielStartenTxt, spielerHinzufuegenTxt, optionenTxt,
                    beendenTxt, '', '');
  repeat
    menu(wahl, blue, menuText);
    if testMode then menuText:= 'memavail: &' + int2str(memavail) + '  maxavail: ' + int2str(maxavail)
                else menuText:= VersionText;
    case wahl of
      1: if spieler = 0 then menuText:= nibbtext.keinSpielerGewaehltTxt else
         begin
           for i := 1 to maxSpieler do
             if schlange[i] <> nil then sFarben[i] := schlange[i]^.farbe;
           if nibblevl.auswahl(nibbluni.bFarb, nibbluni.wFarb, sFarben) then main;
         end;
      2: nibbluni.spielerHinzufuegen;
      3: begin
           nibbluni.optionen;
           nibbmenu.initMenu(4, spielStartenTxt, spielerHinzufuegenTxt,
                             optionenTxt, beendenTxt, '', '');
         end;
    end;
  until wahl = menuEndNummer;
end;

begin
  init;
  auswahl;
  ende;
end.