unit nibbmaus;

INTERFACE
const
  mausLinks = 209;
  mausRechts = 210;

  function init: boolean;
  procedure versteckeCursor;
  procedure zeigeCursor;
  function richtung: byte;
  procedure daten( var mX, mY, mT: byte );
  function bewegt: boolean;

IMPLEMENTATION
var
  m: Array[1..4] Of Word;
  richtungsKey, altKey: byte;
  sichtbar: boolean;

PROCEDURE Mausasm(var m: array of word); assembler;
ASM
  LES DI,m
  MOV AX,ES:[DI]
  MOV BX,ES:[DI+2]
  MOV CX,ES:[DI+4]
  MOV DX,ES:[DI+6]
  INT $33
  MOV ES:[DI],AX
  MOV ES:[DI+2],BX
  MOV ES:[DI+4],CX
  MOV ES:[DI+6],DX
END;

procedure daten( var mX, mY, mT: byte );
begin
  mausASM(m);
  mX:= (m[3] div 8 + 1);
  mY:= (m[4] div 8 + 1);
  mT:= m[2];
end;

function bewegt: boolean;
var
  altX, altY: word;
begin
  altX:= m[3];
  altY:= m[4];
  mausASM(m);
  bewegt:= not( (altX = m[3]) and (altY = m[4]) and (m[2] = 0) );
end;

function richtung: byte;
begin
  altKey:= richtungsKey;
  mausasm(m);
  case m[2] of
    1: richtungsKey:= mausLinks;
    2: richtungsKey:= mausRechts;
    else richtungsKey:= 0;
  end;
  if richtungsKey = altKey then richtung:= 0
                           else richtung:= richtungsKey;
end;

procedure zeigeCursor;
begin
  if not( sichtbar ) then
  begin
    sichtbar:= TRUE;
    ASM
      MOV AX, 0001h
      INT 33h
    END;
  end;
end;

procedure versteckeCursor;
begin
  if sichtbar then
  begin
    sichtbar:= FALSE;
    ASM
      MOV AX, 0002h
      INT 33h
    END;
  end;
end;

function init: boolean;
begin
  if Mem[MemW[0:$cc+2]:MemW[0:$cc]] = $cf then init:= false else                           {mouse.com gestartet?}
  begin
    m[1]:=0;
    Mausasm(m);       {0 = Initialisierung}
    m[1]:=1;
    Mausasm(m);       {1 = sichtbar machen}
    m[1]:=3;
    Mausasm(m);       {3 = Daten uebermitteln}
    sichtbar:= TRUE;
    init:= true;
  end;
end;

end.