unit nibbmenu;

INTERFACE
uses
  crt, nibbmaus;
const
  menuMax = 6;
  menuTextLaenge = 24;
var
  menuEndNummer: byte;

  procedure initMenu(nEndNr: byte; s1, s2, s3, s4, s5, s6: string);
  procedure menu(var mPos: byte; mFarbe: byte; menuText: string);
  procedure hilfText(x: string; zurueckspringen: boolean);

IMPLEMENTATION
type
  mTextType = record
                txt: string[24];
                hell: byte;
              end;
var
  mt: array[1..menuMax] of mTextType;

procedure initMenu(nEndNr: byte; s1, s2, s3, s4, s5, s6: string);
var
  i: byte;
  procedure menuInit(nummer: byte; text: string);
  var
    k: byte;
  begin
    k:= 1;
    while ((k < length(text)) and (text[k] <> '&')) do
      inc(k);
    if text[k] = '&' then mt[nummer].hell:= k
                     else mt[nummer].hell:= 0;
    delete(text, mt[nummer].hell, 1);
    mt[nummer].txt:= text;
  end;
begin
  menuEndNummer:= nEndNr;
  menuInit(1, s1);
  menuInit(2, s2);
  menuInit(3, s3);
  menuInit(4, s4);
  menuInit(5, s5);
  menuInit(6, s6);
end;

procedure menu(var mPos: byte; mFarbe: byte; menuText: string);
var
  ch: char;
  menuZeilen, menuBreite, mXpos, mYpos,{8} i, nPos: byte;
  gewaehlt: boolean;
  procedure schreibText(nummer: byte; aktiv: boolean);
  begin
    if aktiv then
    begin
      textcolor(white);
      textbackground(lightred);
    end
    else
    begin
      textcolor(lightgray);
      textbackground(mFarbe);
    end;
    gotoxy((mXpos + 2), (mYpos - 1 + nummer * 2));
    nibbmaus.versteckeCursor;
    write(mt[nummer].txt);
    textcolor(yellow);
    gotoxy((mXpos + 1 + mt[nummer].hell), (mYpos - 1 + nummer * 2));
    write(mt[nummer].txt[mt[nummer].hell]);
    nibbmaus.zeigeCursor;
  end;
  procedure mAUSwertung;
  var
    mX, mY, mTaste, mX2, mY2, mTaste2: byte;
  begin
    nibbmaus.daten( mX, mY, mTaste );
    repeat until not(nibbmaus.bewegt);
    nibbmaus.daten( mX2, mY2, mTaste2 );
{    gotoxy(1, 25); write(mX: 6, mY: 6);}
    if ( ( mX = mX2 ) and ( mY = mY2 ) ) then
    if ( ( mY - mYpos + 1) mod 2 = 0 ) and
       ( mx > mXpos + 1 ) and ( mY > mYpos )  and
       ( mY < mYpos + 2 * menuZeilen ) then
    begin
      mY:= (mY - mYpos + 1) div 2;
      if mX < ( mXpos + 2 + length( mt[mY].txt ) ) then
      begin
        nPos:= mY;
        if mTaste = 1 then gewaehlt:= TRUE;
      end;
    end;
  end;

begin
  menuZeilen:= 0;
  nPos:= mPos;
  repeat
    inc(menuZeilen);
  until ((mt[menuZeilen].txt = '') or (menuZeilen = menuMax));
  if mt[menuZeilen].txt = '' then dec(menuZeilen);
  menuBreite:= 1;
  for i:= 1 to menuZeilen do
    if length(mt[i].txt) > menuBreite then menuBreite:= length(mt[i].txt);
  if odd(menuBreite) then inc(menuBreite, 3) else inc(menuBreite, 4);
  mXpos:= (80 - menuBreite) div 2;
  mYpos:= (25 - menuZeilen * 2) div 2;
  window(mXpos, mYpos, (mXpos + menuBreite), (mYpos + menuZeilen * 2));
  textbackground(mFarbe);
  clrscr;
  window(1, 1, 80, 25);
  hilfText(menuText, false);
  for i:= 1 to menuZeilen do schreibText(i, (mpos = i));
  gewaehlt:= false;
  nibbMaus.zeigeCursor;
  repeat
    if nibbmaus.bewegt then mAUSwertung;
    if keypressed then
    begin
      ch:= readkey;
      if ord(ch) = 0 then
      begin
        ch:= readkey;
        case upcase(ch) of
          'H': if mPos > 1 then nPos:= mPos - 1 else nPos:= menuZeilen;
          'P': if mPos < menuZeilen then nPos:= mPos + 1 else nPos:= 1;
        end;
      end
      else
      case upcase(ch) of
        char(27): begin
                    nPos:= menuEndNummer;
                    gewaehlt:= true;
                  end;
        char(13): gewaehlt:= true;
        else
        for i:= 1 to menuZeilen do
          if mt[i].hell > 0 then
            if upcase(ch) = upcase(mt[i].txt[mt[i].hell]) then
            begin
              nPos:= i;
              gewaehlt:= true;
            end;
      end;
    end;
    if nPos <> mPos then
    begin
      schreibText(mPos, FALSE);
      schreibText(nPos, TRUE);
      mPos:= nPos;
    end;
  until gewaehlt;
  nibbMaus.versteckeCursor;
  window(mXpos, mYpos, (80 - mXpos), (mYpos + menuZeilen * 2));
  textbackground(mFarbe);
  clrscr;
  window(1, 1, 80, 25);
end;

procedure hilfText(x: string; zurueckspringen: boolean);
var
  i, altx, alty: byte;
begin
  altx:= wherex;
  alty:= wherey;
  gotoxy(1, 25);
  textbackground(lightgray);
  textcolor(black);
  for i:= 1 to length(x) do
    if wherex < 80 then
    case x[i] of
      '~': textcolor(black);
      '&': textcolor(red);
      else
        begin
          if x[i] = ' ' then textcolor(black);
          write(x[i]);
        end;
    end;
  clreol;
  if zurueckspringen then gotoxy(altx, alty);
end;

end.