unit nibbsnak;

INTERFACE
uses
  crt, nibblevl, nibbrule, nibbuffr;
type
  pPos = ^tPos;
  tpos = record
           xpos, ypos: byte;
           verweis: pPos;
         end;
  pSchlange = ^tSchlange;
  tschlange = object
    buffer: pBuffer;
    lebt: boolean;
    kopf, schwanz: pPos;
    name: string;
    todesUrsache, wachstum, farbe, nummer, punkte, links, rechts, oben, unten: byte;
    constructor init(nName: string; nNummer, nFarbe, nL, nR, nO, nU: byte);
    function bewege: boolean;
    procedure getNewDir(eingabe: byte);
    procedure message(nachricht: string);
    procedure aufstellen;
    procedure abbauen;
    destructor ende;
  end;

IMPLEMENTATION
const
  maxSpieler = 5;

procedure tschlange.abbauen;
var
  temp: pPos;
begin
  while schwanz <> nil do
  begin
    nibbLevl.zuHintergrund(schwanz^.xpos, schwanz^.ypos);
    temp:= schwanz;
    schwanz:= schwanz^.verweis;
    dispose(temp);
  end;
end;

procedure tSchlange.message(nachricht: string);
var
  boxGroesse: byte;
begin
  boxGroesse:= round(80 / maxSpieler);
  textbackground(farbe);
  gotoxy((2 + (nummer - 1) * boxGroesse), 25);
  write('              ');
  if farbe = 7 then textcolor(8) else textcolor(7);
  gotoxy((3 + (nummer - 1) * boxGroesse), 25);
  write(nachricht);
end;

procedure tSchlange.aufstellen;
const
  sLaenge = 2;
var
  temp: pPos;
  i, j: byte;
begin
  if schwanz = nil then
  begin
    lebt:= true;
    new(buffer);
    buffer^.init(startpos[nummer].richtung);
    new(kopf);
    kopf^.xpos:= startpos[nummer].x;
    kopf^.ypos:= startpos[nummer].y;
    kopf^.verweis:= nil;
    schwanz:= kopf;
    nibbLevl.malSchlange(kopf^.xpos, kopf^.ypos, nummer);
    wachstum:= (sLaenge - 1);
    j:= wachstum;
    for i:= 1 to j do bewege;
  end;
end;

constructor tSchlange.init(nName: string; nNummer, nFarbe, nL, nR, nO, nU: byte);
begin
  name:= nName;
  nummer:= nNummer;
  punkte:= 0;
  farbe:= nFarbe;
  links:= nL;
  rechts:= nR;
  oben:= nO;
  unten:= nU;
  todesUrsache := 0;
  schwanz:= nil;
end;

function tSchlange.bewege: boolean;
var
  temp: pPos;
  richtung, neux, neuy: byte;
  gestorben: boolean;

  procedure sterben;
  var
    anAus: boolean;
  begin
    anAus:= true;
    temp:= schwanz;
    while temp <> nil do
    begin
      if anAus then malSchlange(temp^.xpos, temp^.ypos, nummer)
               else zuHintergrund(temp^.xpos, temp^.ypos);
      anAus:= not(anAus);
      temp:= temp^.verweis;
    end;
    malSchlange(kopf^.xpos, kopf^.ypos, nummer);
  end;

begin
  gestorben:= false;
  if lebt then
  begin
    richtung:= buffer^.get;
    neux:= kopf^.xpos;
    neuy:= kopf^.ypos;
    case richtung of
      1: if kopf^.ypos = 1 then neuy:= 48 else dec(neuy);
      2: if kopf^.xpos = 80 then neux:= 1 else inc(neux);
      3: if kopf^.ypos = 48 then neuy:= 1 else inc(neuy);
      4: if kopf^.xpos = 1 then neux:= 80 else dec(neux);
    end;
    if ((nibbLevl.feld[neux, neuy] <> nibbLevl.leeresFeld)
       and (nibbLevl.feld[neux, neuy] < 100)) then
    begin
      todesUrsache := nibbLevl.feld[ neux, neuy ];
      sterben;
      message('Game Over!');
      lebt:= false;
    end
    else
    begin               {neuen Kopf erzeugen}
      if ((nibbLevl.feld[neux, neuy] > 100) and (nibbLevl.feld[neux, neuy] < 120)) then
      begin             {zahl auswerten}
        inc(wachstum, nibbRule.holWachs(nibbLevl.feld[neux, neuy], nummer));
        if odd(neuy) then nibbLevl.feld[neux, (neuy + 1)]:= nibbLevl.leeresFeld
                     else nibbLevl.feld[neux, (neuy - 1)]:= nibbLevl.leeresFeld;
      end;
      new(temp);
      kopf^.verweis:= temp;
      temp^.verweis:= nil;
      temp^.xpos:= neux;
      temp^.ypos:= neuy;
      kopf:= temp;
      nibbLevl.malSchlange(neux, neuy, nummer);
    end;
    if wachstum > 0 then dec(wachstum) else
      if schwanz <> nil then
      begin             {Schwanz loeschen}
        nibbLevl.zuHintergrund(schwanz^.xpos, schwanz^.ypos);
        temp:= schwanz;
        schwanz:= schwanz^.verweis;
        dispose(temp);
      end;
  end
  else {schon tot...}
  if schwanz <> nil then {...aber noch nicht abgebaut}
  begin
    abbauen;
    nibbRule.gibGesammelte(nummer);
    gestorben:= true;
  end;
  bewege:= not(gestorben);
end;

procedure tSchlange.getNewDir(eingabe: byte);
begin
  if eingabe = links then buffer^.put( 4, (links = oben) ) else
  if eingabe = rechts then buffer^.put( 2, (links = oben) ) else
  if eingabe = oben then buffer^.put(1, FALSE) else
  if eingabe = unten then buffer^.put(3, FALSE);
end;

destructor tSchlange.ende;
begin
  buffer^.ende;
  dispose(buffer);
  abbauen;
end;

end.